class SeekerME(parentObj) of SeekerPX(parentObj) from SeekerPX.cc custom
//
*- Name.......Multi-Edit Seeker
*- Author.....Todd Kreuter
*- For........dBASE Plus, dB2K 

*- Description
// Paint-box handled seeker control based on the SeekerPX class.
// Multiple edits have been predefined in this subclass for
// convienence so that one does not have to drop multiple 
// SPXEdit controls. Unused edits (not datalinked) are relaesed
// in the beforeOpen method.
//

	*- Edit Controls
   this.Edit1 = new SPXEdit(this)
   with (this.Edit1)
   	width = 100
   endwith

   this.Edit2 = new SPXEdit(this)
   this.Edit3 = new SPXEdit(this)
   this.Edit4 = new SPXEdit(this)
   this.Edit5 = new SPXEdit(this)

   function beforeOpen
   *******************
   	local aEdits, nSize, i

      aEdits = new array()
      aEdits.add(this.Edit1)
      aEdits.add(this.Edit2)
      aEdits.add(this.Edit3)
      aEdits.add(this.Edit4)
      aEdits.add(this.Edit5)

      nSize = aEdits.size

      for i = 1 to aEdits.size
         if EMPTY(aEdits[i].dataLink)
         	aEdits[i].release()
         endif
      endfor

      release object aEdits

      return SeekerPX::beforeOpen()

endclass

class SeekerPB(parentObj) of SeekerPX(parentObj) from SeekerPX.cc custom
//
*- Name.......Multi-Edit Seeker
*- Author.....Todd Kreuter
*- For........dBASE Plus, dB2K 

*- Description
// Paint-box handled seeker control based on the SeekerPX class.
// Multiple edits have been predefined in this subclass for
// convienence so that one does not have to drop multiple 
// SPXEdit controls. Unused edits (not datalinked) are relaesed
// in the beforeOpen method.

// Navigation Buttons have been added.
//

	with (this)
   	width = 136
   endwith

	*- Navigation Buttons
   this.Back = new PUSHBUTTON(this)
   with (this.Back)
      onClick	= class::Navigate_onClick
      height 	= 17
      left		= 0
      top 		= 0
      width 	= 14
      text 		= ""
      speedBar = true
      upBitmap = "RESOURCE TS_PREV"
      speedTip	= "Previous"
   endwith

   this.Next = new PUSHBUTTON(this)
   with (this.Next)
      onClick	= class::Navigate_onClick
      height	= 17
      left 		= 15
      top 		= 0
      width 	= 14
      text 		= ""
      speedBar = true
      upBitmap = "RESOURCE TS_NEXT"
      speedTip = "Next"
   endwith

	*- Edit Controls
   this.Edit1 = new SPXEdit(this)
   with (this.Edit1)
   	width = 100
      left = 30
   endwith

   this.Edit2 = new SPXEdit(this)
   this.Edit3 = new SPXEdit(this)
   this.Edit4 = new SPXEdit(this)
   this.Edit5 = new SPXEdit(this)

   function beforeOpen
   *******************
   	local aEdits, nSize, i

      aEdits = new array()
      aEdits.add(this.Edit1)
      aEdits.add(this.Edit2)
      aEdits.add(this.Edit3)
      aEdits.add(this.Edit4)
      aEdits.add(this.Edit5)

      nSize = aEdits.size

      for i = 1 to aEdits.size
         if EMPTY(aEdits[i].dataLink)
         	aEdits[i].release()
         endif
      endfor

      release object aEdits

      return SeekerPX::beforeOpen()

	function Navigate_onClick
   *************************
	*- Navigation buttons onClick Code
   *- This uses the SeekerPX method onNavigateKey to perform
   // the navigation. All we have to do is supply the right
   // keyCode (documented in SeekerPX).

   	local nKey
      nKey = 40

      if this.name = "BACK"
      	nKey = 38
      endif

      if NOT this.parent.focus
	      this.parent.setFocus(true)
      endif

      this.parent.onNavigateKey(nKey)

      return

endclass

