Class TMPQuery2 of TMPQuery from "TMPQuery.cc" custom

/*

this subclass adds a method to create an index
in descending order.

The method works exactly the same as the 
CreateIndex method contained in the
super class.

*/


   function CreateIndexDescending(tagName, tagExpression)
   ********************
   *- Type:		Custom
   *- Purpose:	Create an index tag
   *- Params:	tagName - Index Name
   	//			taxExpression - Index Expression
   *- Return:	Success on creating index tag (Logical)

      try

         local bCreate, bActive, dIndex
         bCreate	= true
         bActive	= this.active

         if PCOUNT() = 1
            // Assume one field tag
            tagExpression = tagName
         endif

			if bActive
				this.setActive(false)
         endif

         dIndex = new DBFIndex()
         dIndex.indexName  = tagName
         dIndex.expression = tagExpression
         ****************************
         dIndex.descending = true
         ****************************
         this.database.createIndex(this.fullPath, dIndex)

			if bActive
         	this.setActive(true)
         endif

      catch(exception e)
         bCreate = false

         local cMsg
         cMsg  = e.message + chr(13)
         cMsg += "Tag Name  : " + tagName + chr(13)
         cMsg += "Expression: " + tagExpression

         MSGBOX(cMsg, "Cannot Create Index", 16)

      endtry

      return bCreate




EndClass
