/*
    ZSEEKER.CC
    Peter Rorlick
    March 11, 1999
*/
CLASS zSeeker( fArg ) of Seeker( fArg ) custom

* By Peter Rorlick, Feb 1998
*  Does a SEEK on Backspace or Del.
*  Adds SeekPrefix functionality.
*  Yellow background when in focus (disabled by JPMartel)
*  Seeks in the work area described by the .Alias property (optional).
*  Beeps when seek fails.
*  Goes back to original row (not bottom) when seek fails.

  protect datalink // added by Ken Mayer
  this.BorderStyle = 7
	// yellow background when in focus.
	// this.ColorHighlight = 'N/RG+'  
	// this.ColorNormal='N/W+'
  this.Height = 1
    // Modify this when a SET KEY TO ... is active.
  This.SeekPrefix  = ""   

  this.Alias = null       // This can be changed in a form's OnOpen.
                          // Does not apply when dealing with a RowSet.

  FUNCTION key( nChar, nPosition )
    if nextkey() # 0
      // Wait until there are no keystrokes pending, and...
      RETURN ( nChar # 255 )     // ...ignore keystroke if special key
    endif
    if nChar == 255
      if not empty( this.value )  //  .and. ;
             //  ( this.lFound .or. nPosition <= this.nMaxPos )
        this.lFound = this.seek()
        if not this.lFound
          ?? chr( 7 )  // beep
          keyb "{End}" + "{Backspace}"   // "Reject" the last char and force another seek.
        endif
      else
        * The seeker is empty, so go top:
        if form.rowset == null       // if xbase:
          go top
        else
          this.seekRowset.first()
        endif
      endif
      if this.tabAfter > 0
        // Stuff tab if position is greater than tabAfter
        nChar = iif( nPosition > this.tabAfter, 9, 0 )
      else
        nChar = 0
      endif
    else
      if ((nChar > 31 .AND. nChar < 255) .OR.;
                       nChar = 7 .OR. nChar = 8 .OR. nChar = 127)  // trap printable chars or Del or Backspace.
        // Stuff special key to refire key event
        keyboard chr(255)   // was: keyb "{255}" but bug in VdB makes this malfunction.
      endif
    endif
    RETURN nChar


  PROCEDURE NormalizedValue
    RETURN This.SeekPrefix + upper( trim( this.Value ))


  PROCEDURE xSeek
    local nSaveRecn, lRet, nSaveWorkArea
    nSaveWorkArea = WorkArea()
    if this.Alias # NULL
      select (this.Alias)
    endif
    nSaveRecn = RECN()
    lRet = seek( this.normalizedValue() )
    if eof()               // Always move record pointer to real record
      * goto bottom  // This was Seeker's original behavior.
      if nSaveRecn <= RECC()
        GO nSaveRecn
      else
        goto bottom
      endif
    endif
    select (nSaveWorkArea)
    RETURN lRet

  FUNCTION oSeek
    local lRet, bBookMark
    bBookMark = this.seekRowset.BookMark()
    lRet = this.seekRowset.findKey( this.normalizedValue() )   // Original seeker had FindKeyNearest()
    if not lRet
      * this.seekRowset.next( -1 )   // This was Seeker's original behavior.
      this.SeekRowset.goto(bBookMark)   // back to the row we were at before the seek.
      if ( this.seekRowset.endOfSet )
        this.seekRowset.first()
      endif
    endif
    RETURN lRet

ENDCLASS
